#!/usr/bin/wish


#    Copyright 2003 Regis Damongeot

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#window title
wm title . "TkDVD 1.6"
set burning_device "/dev/sr0"
set command_line "growisofs -Z $burning_device"
set volume_id ""
set volume_id_o ""
set option_joliet_ext ""
set option_rr_ext ""
set option_rra_ext ""
set option_pad ""
set file_list ""
set only_one_file ""
set input ""
set total_file_size_f "0 Ko"
set space_left_f "4,377 Go"
set selected_directory "[pwd]"
set iso_file ""
#needed to not have too large precision when show total files size
set tcl_precision 4

#trace add variable burning_device write { set command_line "growisofs -Z $burning_device" }

#Create frame for burn type
frame .frame_burn_type -background #f5f5f5
pack .frame_burn_type -fill x
radiobutton .frame_burn_type.burn_dvd -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Burn a DVD" -command enable_burn_dvd_options -variable burn_type -value burn_dvd
.frame_burn_type.burn_dvd select
radiobutton .frame_burn_type.create_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Only create iso9660 image" -command { .frame_burn_type.open_iso configure -state normal } -state disabled -variable burn_type -value create_iso
radiobutton .frame_burn_type.burn_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Burn iso9660 image" -command { disable_burn_dvd_options } -variable burn_type -value burn_iso
button  .frame_burn_type.open_iso -highlightbackground red -text "Open" -state disabled -command choose_iso_file
entry .frame_burn_type.iso_file -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable iso_file -width 35
pack .frame_burn_type.burn_dvd .frame_burn_type.create_iso .frame_burn_type.burn_iso .frame_burn_type.open_iso .frame_burn_type.iso_file -side left

# create frame for command line and burning device
frame .frame_command_line -background #f5f5f5
pack .frame_command_line -fill x
label .frame_command_line.label_b_device -bg #ffffff -text "Burning device:"
entry .frame_command_line.b_device -relief flat -bg white -highlightbackground blue -highlightcolor blue -state normal -textvariable burning_device
# -validate focusout -validatecommand refresh_cmd_line
entry .frame_command_line.cmd_line -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable command_line -width 50
button .frame_command_line.go_button -text "Burn" -command { refresh_cmd_line; Launch }
pack .frame_command_line.label_b_device .frame_command_line.b_device .frame_command_line.cmd_line .frame_command_line.go_button -side left

#frame for volume id, app id, etc
frame .volume_id -background #f5f5f5
pack .volume_id -fill x
label .volume_id.label_vid -bg #f5f5f5 -text "Volume ID:"
entry .volume_id.volume_id -relief flat -bg white -highlightbackground blue -highlightcolor blue  -disabledbackground #f5f5f5 -state normal -textvariable volume_id_o
pack .volume_id.label_vid .volume_id.volume_id -side left

#create frame for options buttons
frame .options_top -background #f5f5f5
frame .options_bottom -background #f5f5f5
pack .options_top -fill x
pack .options_bottom -fill x
checkbutton .options_top.joliet_ext -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "add Joliet extensions (-J)" -variable option_joliet_ext -offvalue "" -onvalue "-J" -command refresh_cmd_line
checkbutton .options_top.rr_ext -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "add Rock Ridge extensions (-R)" -variable option_rr_ext -offvalue "" -onvalue "-R"  -command refresh_cmd_line
checkbutton .options_top.pad -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "pad (Highly Recommanded) (-pad)" -variable option_pad -offvalue "" -onvalue "-pad"  -command refresh_cmd_line
checkbutton .options_bottom.rra_ext -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "add anonymous Rock Ridge extensions (all file set to r--r--r-- or +x if executable) (-r)" -variable option_rra_ext -offvalue "" -onvalue "-r"  -command refresh_cmd_line
pack .options_top.joliet_ext .options_top.rr_ext .options_bottom.rra_ext .options_top.pad -side left

#create frame for file manipulations
frame .files_manipulations -background #f5f5f5
pack .files_manipulations  -fill x
button .files_manipulations.add -highlightbackground red -text "Add files" -command { if { [catch { .file_selection.open cget -state }] } { create_file_list [FileOpen $selected_directory] } }
button .files_manipulations.add_d -highlightbackground red -text "Add Directory" -command add_d
button .files_manipulations.delete -highlightbackground red -text "Delete file/directory" -command delete_files
button .files_manipulations.clear -highlightbackground red -text "Clear list" -command { set file_list ""; refresh_cmd_line; refresh_total_file_size }
label .files_manipulations.label_file_size -bg #f5f5f5 -text "Total Used Space:"
entry .files_manipulations.show_file_size -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable total_file_size_f -width 10
label .files_manipulations.label_space_left -bg #f5f5f5 -text "Space Left:"
entry .files_manipulations.show_space_left -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable space_left_f -width 10
pack .files_manipulations.add .files_manipulations.add_d .files_manipulations.delete .files_manipulations.clear .files_manipulations.label_file_size .files_manipulations.show_file_size .files_manipulations.label_space_left .files_manipulations.show_space_left -side left

#create frame for file liste
frame .file_list
listbox .file_list.list -bg #f5f5f5 -listvariable file_list -heigh 10 -yscrollcommand { .file_list.scroll_bar set }
scrollbar .file_list.scroll_bar -command { .file_list.list yview }
pack .file_list -fill both -expand false
pack .file_list.scroll_bar -side right -fill y
pack .file_list.list -fill x

#create output frame
frame .output
text .output.log -bg #f5f5f5 -relief ridge -setgrid true -yscrollcommand { .output.scroll_bar set }
scrollbar .output.scroll_bar -command { .output.log yview }
pack .output.scroll_bar -side right -fill y
pack .output.log -side left -fill both -expand true
pack .output -fill both -expand true

#proc part

proc refresh_cmd_line {} {
	global option_joliet_ext option_rr_ext option_rra_ext file_list volume_id option_pad burn_type command_line burning_device iso_file
	if { $burn_type == "burn_dvd" } {
		check_volume_id
		if { "$option_rr_ext" == "-R" && "$option_rra_ext" == "-r" } {
			set command_line "You cant set Anonymous RR ext and normal RR ext"
			#desactive le bouton burn pour eviter les erreurs
			.frame_command_line.go_button configure -state disabled
		} else {
			set command_line "[concat growisofs -Z $burning_device $volume_id $option_joliet_ext $option_rr_ext $option_rra_ext $option_pad -graft-points [file_list_w_modif_dir $file_list]]"
			#reactive le bouton burn si tt est ok
			if { [.frame_command_line.go_button cget -state] == "disabled" } { .frame_command_line.go_button configure -state normal }
		}
	} elseif { $burn_type == "burn_iso" } {
		set command_line "growisofs -Z $burning_device=$iso_file"
	}
	return 1
}

proc file_list_w_modif_dir { file_list_to_modif } {
	puts "$file_list_to_modif"
	set file_list_to_modif_f ""
	#set modified false
	for { set i 0 } { $i < [llength $file_list_to_modif]} { incr i } {
		if { [file isdirectory [lindex $file_list_to_modif $i]] } {
			#if { [string match -nocase *\\\\* [lindex $file_list_to_modif $i]] } {
			#	#contains \\ in directory name, esacping with '\\' due to -graft point option
			#	set where_eq [string first \\\\ [lindex $file_list_to_modif $i]]
			#	lset file_list_to_modif $i [string replace [lindex $file_list_to_modif $i] $where_eq [expr $where_eq+1] "\\\\\\\\\\\\\\\\"]
			#	#set modified true
			#}
			#if { [string match -nocase *=* [lindex $file_list_to_modif $i]] } {
			#	#contains = in directory name, esacping with '\\' due to -graft point option
			#	set where_eq [string first = [lindex $file_list_to_modif $i]]
			#	lset file_list_to_modif $i [string replace [lindex $file_list_to_modif $i] $where_eq $where_eq \\\\=]
			#	#set modified true
			#}
			set file_list_to_modif [lreplace $file_list_to_modif $i $i "[lindex [split [lindex $file_list_to_modif $i] /] end]/=[lindex $file_list_to_modif $i]"]
		} else {
			#if { [file isfile [lindex $file_list_to_modif $i]] && [string match -nocase *\\\\* [lindex $file_list_to_modif $i]] } {
				#set where_eq [string first \\\\ [lindex $file_list_to_modif $i]]
				#lset file_list_to_modif $i [string replace [lindex $file_list_to_modif $i] $where_eq [expr $where_eq+1] "\\\\\\\\\\\\\\\\"]
				#set modified true
			#}
			#if { [file isfile [lindex $file_list_to_modif $i]] && [string match -nocase *=* [lindex $file_list_to_modif $i]] } {
			#	set where_eq [string first = [lindex $file_list_to_modif $i]]
			#	lset file_list_to_modif $i [string replace [lindex $file_list_to_modif $i] $where_eq $where_eq \\\\=]
			#	#set modified true
			#}
		}
	}
	#if { $modified == true } { return [eval concat $file_list_to_modif] } else { return $file_list_to_modif }
	return $file_list_to_modif
}

#validatecommand must be after the called proc
.frame_command_line.b_device configure -validate focus -validatecommand refresh_cmd_line

proc refresh_total_file_size {} {
	global file_list total_file_size_f space_left_f command_line
	#set local var total_file_size_type cause if total_file_size < 1024 octets, total_file_size isnt set
	set total_file_size_type "Ko"
	#set local var total_file_size cause if llength $file_list > 1 then $total_file_size is not set for the fisrt iteration of "for"
	set total_file_size 0
	#attention: $total_file_size is in Ko to prevent overflow if $total_file_size > 2go
	if {[llength $file_list] == 0} {
		set total_file_size 0
	} elseif { [llength $file_list] == 1 } {
		if {[file isdirectory [lindex $file_list 0]]} {
			set total_file_size [expr [lindex [exec du -ks -- [lindex $file_list 0]] 0] - [file size [lindex $file_list 0]]/1024]
		} else { set total_file_size [expr [file size [lindex $file_list 0]]/1024.] }
	} else {
		for { set i 0 } {$i < [llength $file_list]} {incr i} {
			if {[file isdirectory [lindex $file_list $i]]} {
				set total_file_size [expr $total_file_size + [expr [lindex [exec du -ks -- [lindex $file_list $i]] 0] - [file size [lindex $file_list 0]]/1024]]
			} else { set total_file_size [expr ($total_file_size + [expr ([file size [lindex $file_list $i]])/1024.])] }
		}
	}
	# sauve total_file_size in order to reuse it to calculate space_left more easily
	set space_left $total_file_size
	if { $total_file_size > 1048576 } {
		#exact maximum size: 4589843.75. Oversized cause "du" return > real file size due to indirect blocks
		if { $total_file_size > 4589850 } {
			set command_line "You need to overburn if you want to burn all theses files"
			.frame_command_line.go_button configure -state disabled
		}
		set total_file_size [expr (($total_file_size)/1024.)/1024.]
		set total_file_size_type "Go"
	} elseif { $total_file_size > 1024 } {
		set total_file_size [expr ($total_file_size)/1024.]
		set total_file_size_type "Mo"
	} else {
		set total_file_size $total_file_size
		set total_file_size_type "Ko"
	}
	set total_file_size_f "$total_file_size $total_file_size_type"
	switch $total_file_size_type  {
		Go {
			set space_left [expr (4589850 - $space_left)/1024.]
			set space_left_type "Mo"
		}
		Mo {
			set space_left [expr ((4589850 - $space_left)/1024.)/1024.]
			set space_left_type "Go"
		}
		Ko {
			set space_left [expr ((4589850 - $space_left)/1024.)/1024.]
			set space_left_type "Go"
		}
	}
	set space_left_f "$space_left $space_left_type"
}

proc choose_iso_file {} {
	global iso_file_o iso_file
	set iso_file_o [tk_getOpenFile -defaultextension iso -title "ISO Image"]
	if { [llength $iso_file_o] > 1} {
		set iso_file [lindex $iso_file_o 0]
		for { set i 1} {$i < [llength $iso_file_o]} {incr i} {
			set iso_file "$iso_file\\ [lindex $iso_file_o $i]"
		}
	}
	refresh_cmd_line
}

proc check_volume_id {} {
	global volume_id volume_id_o
	set volume_id ""
	if { $volume_id_o == "" } {
		set volume_id ""
	} elseif { [llength $volume_id_o] > 1} {
			set volume_id [lindex $volume_id_o 0]
			for { set i 1} {$i < [llength $volume_id_o]} {incr i} {
				set volume_id "$volume_id\\ [lindex $volume_id_o $i]"
			}
			set volume_id "-V $volume_id"
		} else { set volume_id "-V $volume_id_o" }
}

proc create_file_list { file } {
	global file_list only_one_file
	#mis a 1 o moment de la selection des fichiers, pose pb si on utilise concat car un  fichier avec d espaces sera considere comme plusieurs fichiers
	if { $only_one_file == 1 } {
		lappend file_list $file
	} else {
	#ds le cas contraire (multiple selection) on utilise concact pour eviter davoir tout sur la meme ligne (1 seul element)
		set file_list [concat $file_list $file]
	}
	set only_one_file 0
	#refresh command line entry
	refresh_cmd_line
	refresh_total_file_size
}

proc add_d {} {
	global file_list
	set temp [tk_chooseDirectory]
	set temp_f "[lindex $temp 0]"
	if { $temp != "" } {
		#for {set i 1} { $i < [llength $temp] } {incr i} {
		#	append temp_f "\\ [lindex $temp $i]"
		#}
		lappend file_list $temp
		refresh_cmd_line
		refresh_total_file_size
	}
}

proc delete_files {} {
	global file_list
	#puts $file_list
	#puts [.file_list.list curselection]
	if { "[.file_list.list curselection]" == "" } {
	} else {
		set file_list [lreplace $file_list [.file_list.list curselection] [.file_list.list curselection]]
		refresh_cmd_line
		refresh_total_file_size
	}
	#lreplace file_list 0 end
	#lset file_list [concat $file_list]
	#puts [llength $file_list]
}

proc Launch {} {
	global input command_line
	if [catch {open "|$command_line |& cat"} input] {
		.output.log insert end $command_line\n
	} else {
		fileevent $input readable log_proc
		.output.log insert end "$command_line\n"
	}
}

proc log_proc {} {
	global input
	if [eof $input] {
		catch { close $input }
	} else {
		gets $input line
		.output.log insert end $line\n
		.output.log see end
	}
}

proc disable_burn_dvd_options {} {
	.frame_burn_type.open_iso configure -state normal
	.volume_id.label_vid configure -state disabled
	.volume_id.volume_id configure -state disabled
	.files_manipulations.add configure -state disabled
	.files_manipulations.delete configure -state disabled
	.files_manipulations.clear configure -state disabled
	.options_top.pad configure -state disabled
	.options_bottom.rra_ext configure -state disabled
	.options_top.rr_ext configure -state disabled
	.options_top.joliet_ext configure -state disabled
	.files_manipulations.label_file_size configure -state disabled
}

proc enable_burn_dvd_options {} {
	.frame_burn_type.open_iso configure -state disabled
	.volume_id.label_vid configure -state normal
	.volume_id.volume_id configure -state normal
	.files_manipulations.add configure -state normal
	.files_manipulations.delete configure -state normal
	.files_manipulations.clear configure -state normal
	.options_top.pad configure -state normal
	.options_bottom.rra_ext configure -state normal
	.options_top.rr_ext configure -state normal
	.options_top.joliet_ext configure -state normal
	.files_manipulations.label_file_size configure -state normal
	refresh_cmd_line
}




proc FileOpen_Update {newpath} {
    catch {cd $newpath}
    .file_selection.files delete 0 end
    foreach f [lsort [glob -nocomplain *]] {
	if [file isdirectory $f] {
		append f /
	}
	.file_selection.files insert end $f
    }

    # refresh menu for current directory
    global FileOpen_CurDir selected_directory

    .file_selection.dir.menu delete 0 end
    set path [file split [pwd]]
    set FileOpen_CurDir [lindex $path end]
    set path [lreplace $path end end]
    set curpath {}
    foreach dir $path {
	lappend curpath $dir
	.file_selection.dir.menu insert 0 command -label $dir -command [list FileOpen_Update [eval file join $curpath]]
    }
    set selected_directory $newpath
}

# called function to finish open dialogue
proc FileOpen_Done {} {
	destroy .file_selection
}

# called proc when event click on open
proc FileOpen_Open {} {
    global FileOpen_Value only_one_file FileOpen_File

	if { "[.file_selection.files curselection]" != "" } {
		if { [llength [.file_selection.files curselection]] < 2 } {
			set f [.file_selection.files get [.file_selection.files curselection]]
			if [file isdirectory $f] {
				FileOpen_Update $f
			} else {
        			#puts [$widget.files curselection]
				set FileOpen_File [file join [pwd] $f]
				set only_one_file 1
				FileOpen_Done
    			}
		} else {
			foreach index_selection [.file_selection.files curselection] {
				if [file isfile [.file_selection.files get $index_selection]] {
					lappend FileOpen_File [file join [pwd] [.file_selection.files get $index_selection]]
				}
			}
			FileOpen_Done
			set FileOpen_File [concat $FileOpen_File]
		}
	}
}

# ------------------------------------------------------------------------
# Create window with needed element to select files

proc FileOpen {dir} {
	# Create main open window and name it
	toplevel .file_selection
	wm title .file_selection "File opener ..."

	# Create message
	label .file_selection.msg -text "File to open..."
	pack .file_selection.msg -side top -padx 5 -pady 5 -anchor w

	# Create menu containing the listing of directorys
	menubutton .file_selection.dir -menu .file_selection.dir.menu -textvariable FileOpen_CurDir
	menu .file_selection.dir.menu
	pack .file_selection.dir -side top -padx 5 -pady 5

	# Create listbox containing file listing and his scrollbar
	listbox .file_selection.files  -selectmode extended -yscrollcommand ".file_selection.sb set"
	scrollbar .file_selection.sb -orient ver -command ".file_selection.files yview"
	pack .file_selection.files -side left -fill both -expand on -padx 5 -pady 5
	pack .file_selection.sb -side left -fill y -padx 5 -pady 5

	# double click = open
	bind .file_selection.files <Double-ButtonPress-1> ".file_selection.open invoke"

	# Create Open and Cancel button
	button .file_selection.open -text Open -command "FileOpen_Open" -width 8
	button .file_selection.cancel -text Cancel -command "FileOpen_Done" -width 8
	pack .file_selection.open .file_selection.cancel -side bottom -fill y -padx 5 -pady 5

	# Initialize files list with current directory
	#set dir [pwd]
	FileOpen_Update $dir

	# wait selection
	global FileOpen_File
	set FileOpen_File {}
	tkwait window .file_selection
	return $FileOpen_File
}

